Subject: Re: bug#33781: tramp tests abort on hydra

From: Michael Albinus <[email-masked]>
Date: Wed, 19 Dec 2018 20:53:01 +0100

Glenn Morris <[email-masked]> writes:

Hi Glenn,

>> # getconf LINE_MAX
>
> This returns 2048.
>
> Anyway, I don't think this issue will be specific to hydra.nixos.org.
> I hope eg that you can reproduce it on your own systems using an
> artificially lengthened PATH=/some/long/dummy/thing/.../$PATH
> such that the directory with "sed" is beyond 4096 characters from the
> start of PATH.

Yes, I could reproduce it. The problem is, that there is an upper limit
to the length of the $PATH variable, to be checked by

# getconf PATH_MAX /

On my Ubuntu system this is 4096; I guess there is a similar result on
hydra. Until now, Tramp didn't check this limit, and it isn't a problem
but on hydra. I've added a test for this, and Tramp fires a warning, if
the intended $PATH exceeds the limit.

But this isn't satisfactory. Tramp shall raise an error in this
case. But this would result in complete failing tests on hydra involving
Tramp.

Is there a chance, that we could shorten the $PATH in the Makefile for
tests on hydra, to be shorter than 4096 characters? According to what I
see in the Tramp logs, I would say that the following directories aren't
needed for Tramp tests (to be tested, of course):

/nix/store/bqp3d4yhpx6h60fv8jww5id0nkm44034-patchelf-0.9/bin
/nix/store/63j8mi5vjyxfc89rhjknwxaxqg3a2sx2-paxctl-0.9/bin
/nix/store/iw94llkj05wgaz268mlzvgx8jkbi1ss0-gcc-wrapper-7.3.0/bin
/nix/store/vv4r320p5yd1k01kld62q1lppjxcswhb-gcc-7.3.0/bin
/nix/store/5hir9w0mnrw86yv7sf4qghsard0ccwl1-glibc-2.27-bin/bin
/nix/store/wm8va53fh5158ipi0ic9gir64hrvqv1z-coreutils-8.29/bin
/nix/store/9748iw15rqyd8s5i716hzkh8h6kx4bli-gcc-wrapper-4.8.5/bin
/nix/store/aph39agmihcibk3rp57mlzb27nzfqx15-gcc-4.8.5/bin
/nix/store/gc7p17ps5h3vlrbflhqps7ypnjfhnic5-bazaar-2.7.0/bin
/nix/store/rk6df3iamxmiywq9rlqy72fhvwqhk1qk-gnupg-2.2.11/bin
/nix/store/g9r3l1l839xsxinmkfnsf682dza0gnsy-mercurial-4.7/bin
/nix/store/4p88zybzrsg5vgm09jwylzyw5v9vb6xs-libjpeg-turbo-1.5.3-bin/bin
/nix/store/a72yvnxq9k0g0s9m9kv1s6yrjfg4p4xb-libtiff-4.0.10-bin/bin
/nix/store/kk9hay3dci9rk1aq5fdzznjp01yjbkiw-lcms2-2.9-bin/bin
/nix/store/1icn0kv4czsx6sxp970rzlp0yc3ycspv-ruby-2.5.3/bin
/nix/store/mkhxzd28sc5q94smdlbbk8ldhp0wlw1c-libotf-0.9.16/bin
/nix/store/4i17crc8xvqr94vl0z1c2pd7kfxv11vf-texinfo-6.5/bin
/nix/store/57crgngllpc1dh2y90dc874q5d0z4iiy-freetype-2.9-dev/bin
/nix/store/gvaadn6sby7mv35fb6jq97vz10rd59vs-libpng-apng-1.6.35-dev/bin
/nix/store/ijvpmbvy04g216604w4isj13z0wjdisz-fontconfig-2.12.6-bin/bin
/nix/store/mcx1dlzirfrf0b86qh4bfg3skn2p35p2-libXpm-3.5.12-bin/bin
/nix/store/4ps4yzv9lw772xqkb7sswp0rgmdp3rmn-expat-2.2.6-dev/bin
/nix/store/g3mf4r9viyhkavxbm7n5na2a9mbg2l0w-harfbuzz-1.8.8-dev/bin
/nix/store/z4sr1ydi9gl0gy466vkymmnapcgl7b46-graphite2-1.3.6/bin
/nix/store/32pva7lryj1s9bcc1alpj5jhxxzijh63-fribidi-1.0.5/bin
/nix/store/9mkblf5hgygbm7pvv8ajmn0sar9w5yrd-pango-1.42.1-bin/bin
/nix/store/gfs3wc7w03ddviif75z8a7j6nmd4kjga-jasper-2.0.14-bin/bin
/nix/store/1nnplnv2xn6gh1m66sjcvpw5gm8x0j0n-libdrm-2.4.93-bin/bin
/nix/store/pwd7kz3rqj33mjh6n872nyisxwa294kl-cups-2.2.6-dev/bin
/nix/store/1vf8f6s28kqn3lvgc41yqgrsd4sw0czc-cups-2.2.6/bin
/nix/store/dscmmkbs6g4r0019vcx9114q1hmzc3rb-librsvg-2.42.4/bin
/nix/store/g29v2vm4g95h1z3x1c3b48m6jd9m5dzx-acl-2.2.52-bin/bin
/nix/store/mjpq0xm1zmvr9ybfwrz3dv22znrgr8nc-imagemagick-6.9.9-34-dev/bin
/nix/store/kr0djjvisbh2n1444i8fs9cv43v96m5d-fftw-double-3.3.8-dev/bin
/nix/store/kfalxsmcvr5qrayx35vpmdk6zb8n4lr6-libwebp-1.0.0/bin
/nix/store/10v9wrfsb8dj7qw1s2d77rizxw2szzp6-imagemagick-6.9.9-34/bin
/nix/store/yzq4c2z3i4nj2wxyjxh1brih4kxbdcf5-libungif-4.1.4/bin
/nix/store/sp77lj21zk7ys4jl2y09vaj59kc8s9m7-lcov-1.13/bin
/home/UUUUUUU/.nix-profile/bin
/home/UUUUUUU/work/xmm/scripts
/home/UUUUUUU/work/chandra/scripts
/home/UUUUUUU/bin
/scratch/UUUUUUU/software64/xfce4.12/bin
/scratch/UUUUUUU/software64/xfce4.12/sbin
/usr/lib64/openmpi/bin
/opt/rh/rh-git29/root/usr/bin
/usr/lib64/qt-3.3/bin
/scratch/UUUUUUU/software64/bin
/scratch/UUUUUUU/software64/sbin
/scratch/UUUUUUU/software/bin
/scratch/UUUUUUU/software/sbin
/data/soft/cxc/ciao-install/Linux64/ciao-4.10/bin
/data/soft/cxc/ciao-install/Linux64/ciao-4.10/ots/bin
/data/soft/cxc/ciao-install/Linux64/ciao-4.10/contrib/bin
/data/soft/heasoft/6.25/x86_64/heasoft/x86_64-pc-linux-gnu-libc2.17/bin
/data/soft/sas/xmmsas_20180620_1732/bin
/data/soft/casa/current/bin
/data/soft/funtools/current/x86_64/bin
/data/soft/marx/current/bin
/data/soft/marx/current/lib/marx
/data/soft/scisim/4.0.4/bin
/data/soft/wcstools/current/bin
/data/soft/eclipse/5.0.0/bin
/data/soft/zhtools/3.0.4/bin
/data/soft/imcat/20030419/bin/Linux
/data/soft/imcat/20030419/bin/scripts
/data/soft/cuda/current/bin
/data/soft/simx/2.4.1/bin
/data/soft/starlink/2018A/bin/startcl
/data/soft/starlink/2018A/bin
/data/soft/starlink/2018A/java/jre/bin
/data/soft/starlink/2018A/java/bin
/data/soft/starlink/2018A/starjava/bin

This $PATH shortening shall be applied for filenotify-tests.el,
shadowfile-tests.el, tramp-archive-tests.el and tramp-tests.el.

Best regards, Michael.